"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const component_1 = require("../common/component/component");
class Page extends component_1.Component {
    constructor(geneticCode) {
        super(Object.assign({ className: 'Page' }, geneticCode));
        this.unknown = false;
        if (geneticCode.file)
            serviceModel_1.ServiceModel.getPromise(geneticCode.file + 'L').then((data) => this.checkLanguage(geneticCode.file, data)).fail((data) => this.checkFailed(data));
    }
    getLanguage() {
        return this.language;
    }
    getUnknown() {
        return this.unknown;
    }
    setUnknown(unknown) {
        this.unknown = unknown;
    }
    checkLanguage(file, jSON) {
        this.language = jSON;
        serviceModel_1.ServiceModel.getPromise(file).then((data) => this.checkArray(data)).fail((data) => this.checkFailed(data));
    }
    checkArray(jSON) {
        // jSON = JSON.parse(jSON);
        if (jSON.constructor === Array) {
            for (let index = 0; index < jSON.length; index++) {
                let fJSON = {
                    minWidth: jSON[index]['minWidth'],
                    maxWidth: jSON[index]['maxWidth'],
                    minHeight: jSON[index]['minHeight'],
                    maxHeight: jSON[index]['maxHeight'],
                };
                serviceModel_1.ServiceModel.getPromise(jSON[index]['file']).then((data) => this.checkFrame(data, fJSON)).fail((data) => this.checkFailed(data));
            }
        }
        else {
            let frame = new componentPageFrame_1.ComponentPageFrame({ father: this });
            this.setCurrentPage();
            frame.populate(jSON);
        }
    }
    checkFrame(jSON, fJSON) {
        // jSON = JSON.parse(jSON);
        let frame = new componentPageFrame_1.ComponentPageFrame({ father: this });
        frame.setMinWidth(fJSON.minWidth);
        frame.setMaxWidth(fJSON.maxWidth);
        frame.setMinHeight(fJSON.minHeight);
        frame.setMaxHeight(fJSON.maxHeight);
        this.setCurrentPage();
        frame.populate(jSON);
    }
    checkFailed(data) {
        // console.error('JSONT:' + data);
        if (this.father instanceof componentRouter_1.ComponentRouter)
            this.father.updateFailed(data, this);
    }
    setCurrentPage() {
        let width = document.documentElement.clientWidth;
        let height = document.documentElement.clientHeight;
        for (let index = 0; index < this.getChildrenLength(); index++) {
            let frame = this.getChildAt(index);
            if (frame instanceof componentPageFrame_1.ComponentPageFrame && this.father instanceof componentRouter_1.ComponentRouter) {
                if (frame.getMaxHeight() === undefined || frame.getMaxHeight() >= height) {
                    if (frame.getMinHeight() === undefined || frame.getMinHeight() <= height) {
                        if (frame.getMaxWidth() === undefined || frame.getMaxWidth() >= width) {
                            if (frame.getMinWidth() === undefined || frame.getMinWidth() <= width) {
                                if (this.currentFrame === undefined || this.currentFrame !== frame || this.father.toGo()) {
                                    this.father.went();
                                    this.refreshFrame(frame);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    refreshFrame(frame) {
        this.currentFrame = frame;
        this.getFather().destroyChildElements();
        // frame.setFather(this.getFather());
        this.insert(frame);
        this.renderAfterUpdate();
    }
    addFrame(frame, jSON) {
        if (this.getArrayChild.indexOf(frame) === -1) {
            this.addChild({ child: frame });
            frame.populate(jSON);
        }
    }
}
exports.Page = Page;
const componentPageFrame_1 = require("./componentPageFrame");
const serviceModel_1 = require("../serviceModel/serviceModel");
const componentRouter_1 = require("../common/component/generic/router/componentRouter");
//# sourceMappingURL=page.js.map